Package net.shibboleth.idp.cas.service.impl

# Class ServiceEntityDescriptor

java.lang.Object
org.opensaml.core.xml.AbstractXMLObject
net.shibboleth.idp.cas.service.impl.ServiceEntityDescriptor

All Implemented Interfaces:
  `AttributeExtensibleXMLObject`, `XMLObject`, `SAMLObject`, `SignableSAMLObject`, `CacheableSAMLObject`, `TimeBoundSAMLObject`, `EntityDescriptor`, `SignableXMLObject`

public class ServiceEntityDescriptor extends AbstractXMLObject implements EntityDescriptor
Adapts CAS protocol service metadata onto SAML metadata.

Note that this is not a "usable" object in the sense that it raises exceptions on many operations and returns immutable collections that will throw if modified.

## Field Summary

Fields
Modifier and Type
Field
Description
`private final Service`
`svc`
Underlying CAS service.

### Fields inherited from interface org.opensaml.saml.saml2.common.CacheableSAMLObject

`CACHE_DURATION_ATTRIB_NAME, CACHE_DURATION_ATTRIB_QNAME`

### Fields inherited from interface org.opensaml.saml.saml2.metadata.EntityDescriptor

`DEFAULT_ELEMENT_LOCAL_NAME, DEFAULT_ELEMENT_NAME, ELEMENT_QNAME, ENTITY_ID_ATTRIB_NAME, ID_ATTRIB_NAME, TYPE_LOCAL_NAME, TYPE_NAME`

### Fields inherited from interface org.opensaml.saml.saml2.common.TimeBoundSAMLObject

`VALID_UNTIL_ATTRIB_NAME, VALID_UNTIL_ATTRIB_QNAME`

## Constructor Summary

Constructors
Constructor
Description
`ServiceEntityDescriptor(Service service)`
Creates a new instance that wraps the given CAS service.

## Method Summary

Modifier and Type
Method
Description
`List<AdditionalMetadataLocation>`
`getAdditionalMetadataLocations()`
`AffiliationDescriptor`
`getAffiliationDescriptor()`
`AttributeAuthorityDescriptor`
`getAttributeAuthorityDescriptor(String supportedProtocol)`
`AuthnAuthorityDescriptor`
`getAuthnAuthorityDescriptor(String supportedProtocol)`
`Duration`
`getCacheDuration()`
`List<ContactPerson>`
`getContactPersons()`
`String`
`getEntityID()`
`Extensions`
`getExtensions()`
`String`
`getID()`
`IDPSSODescriptor`
`getIDPSSODescriptor(String supportedProtocol)`
`List<XMLObject>`
`getOrderedChildren()`
`Organization`
`getOrganization()`
`PDPDescriptor`
`getPDPDescriptor(String supportedProtocol)`
`List<RoleDescriptor>`
`getRoleDescriptors()`
`List<RoleDescriptor>`
`getRoleDescriptors(QName typeOrName)`
`List<RoleDescriptor>`
`getRoleDescriptors(QName typeOrName, String supportedProtocol)`
`Signature`
`getSignature()`
`String`
`getSignatureReferenceID()`
`SPSSODescriptor`
`getSPSSODescriptor(String supportedProtocol)`
`AttributeMap`
`getUnknownAttributes()`
`Instant`
`getValidUntil()`
`boolean`
`isSigned()`
`boolean`
`isValid()`
`void`
`setAffiliationDescriptor(AffiliationDescriptor descriptor)`
`void`
`setCacheDuration(Duration duration)`
Throws `UnsupportedOperationException`.
`void`
`setEntityID(String id)`
Throws `UnsupportedOperationException`.
`void`
`setExtensions(Extensions extensions)`
Throws `UnsupportedOperationException`.
`void`
`setID(String newID)`
Throws `UnsupportedOperationException`.
`void`
`setOrganization(Organization organization)`
Throws `UnsupportedOperationException`.
`void`
`setSignature(Signature newSignature)`
Throws `UnsupportedOperationException`.
`void`
`setValidUntil(Instant validUntil)`

### Methods inherited from class org.opensaml.core.xml.AbstractXMLObject

`detach, ensureDOM, getDOM, getElementQName, getIDIndex, getNamespaceManager, getNamespaces, getNoNamespaceSchemaLocation, getObjectMetadata, getParent, getSchemaLocation, getSchemaType, hasChildren, hasParent, isNil, isNilXSBoolean, manageQualifiedAttributeNamespace, prepareAttributeValueForAssignment, prepareElementContentForAssignment, prepareForAssignment, prepareForAssignment, prepareForAssignment, registerOwnID, releaseChildrenDOM, releaseDOM, releaseParentDOM, releaseThisAndChildrenDOM, releaseThisandParentDOM, resolveID, resolveIDFromRoot, setDOM, setElementNamespacePrefix, setElementQName, setNil, setNil, setNoNamespaceSchemaLocation, setParent, setSchemaLocation, setSchemaType`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.opensaml.core.xml.XMLObject

`detach, ensureDOM, getDOM, getElementQName, getIDIndex, getNamespaceManager, getNamespaces, getNoNamespaceSchemaLocation, getObjectMetadata, getParent, getSchemaLocation, getSchemaType, hasChildren, hasParent, isNil, isNilXSBoolean, releaseChildrenDOM, releaseDOM, releaseParentDOM, resolveID, resolveIDFromRoot, setDOM, setNil, setNil, setNoNamespaceSchemaLocation, setParent, setSchemaLocation`

## Field Details

### svc

@Nonnull private final Service svc
Underlying CAS service.

## Constructor Details

### ServiceEntityDescriptor

public ServiceEntityDescriptor(@Nonnull Service service)
Creates a new instance that wraps the given CAS service.

Parameters:
  `service` - CAS service metadata object.

## Method Details

### getEntityID

@Nullable public String getEntityID()

Specified by:
  `getEntityID` in interface `EntityDescriptor`

### setEntityID

public void setEntityID(@Nullable String id)
Throws `UnsupportedOperationException`.

Specified by:
  `setEntityID` in interface `EntityDescriptor`

### getID

@Nullable public String getID()

Specified by:
  `getID` in interface `EntityDescriptor`

### setID

public void setID(@Nullable String newID)
Throws `UnsupportedOperationException`.

Specified by:
  `setID` in interface `EntityDescriptor`

### getExtensions

@Nullable public Extensions getExtensions()

Specified by:
  `getExtensions` in interface `EntityDescriptor`

### setExtensions

public void setExtensions(@Nullable Extensions extensions)
Throws `UnsupportedOperationException`.

Specified by:
  `setExtensions` in interface `EntityDescriptor`

### getRoleDescriptors

@Nonnull @Live public List<RoleDescriptor> getRoleDescriptors()

Specified by:
  `getRoleDescriptors` in interface `EntityDescriptor`

### getRoleDescriptors

@Nonnull @Live public List<RoleDescriptor> getRoleDescriptors(@Nonnull QName typeOrName)

Specified by:
  `getRoleDescriptors` in interface `EntityDescriptor`

### getRoleDescriptors

@Nonnull @Live public List<RoleDescriptor> getRoleDescriptors(@Nonnull QName typeOrName, @Nonnull String supportedProtocol)

Specified by:
  `getRoleDescriptors` in interface `EntityDescriptor`

### getIDPSSODescriptor

@Nullable public IDPSSODescriptor getIDPSSODescriptor(@Nonnull String supportedProtocol)

Specified by:
  `getIDPSSODescriptor` in interface `EntityDescriptor`

### getSPSSODescriptor

@Nullable public SPSSODescriptor getSPSSODescriptor(@Nonnull String supportedProtocol)

Specified by:
  `getSPSSODescriptor` in interface `EntityDescriptor`

### getAuthnAuthorityDescriptor

@Nullable public AuthnAuthorityDescriptor getAuthnAuthorityDescriptor(@Nonnull String supportedProtocol)

Specified by:
  `getAuthnAuthorityDescriptor` in interface `EntityDescriptor`

### getAttributeAuthorityDescriptor

@Nullable public AttributeAuthorityDescriptor getAttributeAuthorityDescriptor(@Nonnull String supportedProtocol)

Specified by:
  `getAttributeAuthorityDescriptor` in interface `EntityDescriptor`

### getPDPDescriptor

@Nullable public PDPDescriptor getPDPDescriptor(@Nonnull String supportedProtocol)

Specified by:
  `getPDPDescriptor` in interface `EntityDescriptor`

### getAffiliationDescriptor

@Nullable public AffiliationDescriptor getAffiliationDescriptor()

Specified by:
  `getAffiliationDescriptor` in interface `EntityDescriptor`

### setAffiliationDescriptor

public void setAffiliationDescriptor(@Nullable AffiliationDescriptor descriptor)

Specified by:
  `setAffiliationDescriptor` in interface `EntityDescriptor`

### getOrganization

@Nullable public Organization getOrganization()

Specified by:
  `getOrganization` in interface `EntityDescriptor`

### setOrganization

public void setOrganization(@Nullable Organization organization)
Throws `UnsupportedOperationException`.

Specified by:
  `setOrganization` in interface `EntityDescriptor`

### getContactPersons

@Nonnull @Live public List<ContactPerson> getContactPersons()

Specified by:
  `getContactPersons` in interface `EntityDescriptor`

### getAdditionalMetadataLocations

@Nonnull @Live public List<AdditionalMetadataLocation> getAdditionalMetadataLocations()

Specified by:
  `getAdditionalMetadataLocations` in interface `EntityDescriptor`

### getUnknownAttributes

@Nonnull public AttributeMap getUnknownAttributes()

Specified by:
  `getUnknownAttributes` in interface `AttributeExtensibleXMLObject`

### getCacheDuration

@Nullable public Duration getCacheDuration()

Specified by:
  `getCacheDuration` in interface `CacheableSAMLObject`

### setCacheDuration

public void setCacheDuration(@Nullable Duration duration)
Throws `UnsupportedOperationException`.

Specified by:
  `setCacheDuration` in interface `CacheableSAMLObject`

### getSignatureReferenceID

@Nullable public String getSignatureReferenceID()

Specified by:
  `getSignatureReferenceID` in interface `SignableSAMLObject`

### isSigned

public boolean isSigned()

Specified by:
  `isSigned` in interface `SignableXMLObject`

### getSignature

@Nullable public Signature getSignature()

Specified by:
  `getSignature` in interface `SignableXMLObject`

### setSignature

public void setSignature(@Nullable Signature newSignature)
Throws `UnsupportedOperationException`.

Specified by:
  `setSignature` in interface `SignableXMLObject`

### isValid

public boolean isValid()

Specified by:
  `isValid` in interface `TimeBoundSAMLObject`

### getValidUntil

@Nullable public Instant getValidUntil()

Specified by:
  `getValidUntil` in interface `TimeBoundSAMLObject`

### setValidUntil

public void setValidUntil(@Nullable Instant validUntil)

Specified by:
  `setValidUntil` in interface `TimeBoundSAMLObject`

### getOrderedChildren

@Nullable @Unmodifiable @NotLive public List<XMLObject> getOrderedChildren()

Specified by:
  `getOrderedChildren` in interface `XMLObject`